<?php

function GFCIWidget_Members($args) {
	$options = get_option(GFCI_MEMBER_WIDGET);
	$gadget_wid = attribute_escape($options['gadget_wid']);
	$gadget_hei = attribute_escape($options['gadget_hei']);
	$endcap_bkgd = attribute_escape($options['endcap_bkgd']);
	$endcap_text = attribute_escape($options['endcap_text']);
	$endcap_links = attribute_escape($options['endcap_links']);
	$content_bkgd = attribute_escape($options['content_bkgd']);
	$content_text = attribute_escape($options['content_text']);
	$content_text2 = attribute_escape($options['content_text2']);
	$content_links = attribute_escape($options['content_links']);
	$content_links2 = attribute_escape($options['content_links2']);
	$content_hlines = attribute_escape($options['content_hlines']);
	$alt_bkgd = attribute_escape($options['alt_bkgd']);
	$gfci_border = attribute_escape($options['gfci_border']);
	$gfci_border2 = attribute_escape($options['gfci_border2']);
	$canvas_path = get_option( gfci_canvas_path );
  extract($args);
  echo $before_widget;
  echo $before_title;
  echo $after_title;
?>

<div id="gfci-member" style="width:<?php echo $gadget_wid; ?>px;border:1px solid #<?php echo $gfci_border2; ?>;"></div>
<script type="text/javascript">
var skin = {};
skin['HEIGHT'] = '<?php echo $gadget_hei; ?>';
skin['BORDER_COLOR'] = '<?php echo $gfci_border; ?>';
skin['ENDCAP_BG_COLOR'] = '<?php echo $endcap_bkgd; ?>';
skin['ENDCAP_TEXT_COLOR'] = '<?php echo $endcap_text; ?>';
skin['ENDCAP_LINK_COLOR'] = '<?php echo $endcap_links; ?>';
skin['ALTERNATE_BG_COLOR'] = '<?php echo $alt_bkgd; ?>';
skin['CONTENT_BG_COLOR'] = '<?php echo $content_bkgd; ?>';
skin['CONTENT_LINK_COLOR'] = '<?php echo $content_links; ?>';
skin['CONTENT_TEXT_COLOR'] = '<?php echo $content_text; ?>';
skin['CONTENT_SECONDARY_LINK_COLOR'] = '<?php echo $content_links2; ?>';
skin['CONTENT_SECONDARY_TEXT_COLOR'] = '<?php echo $content_text2; ?>';
skin['CONTENT_HEADLINE_COLOR'] = '<?php echo $content_hlines; ?>';
google.friendconnect.container.setParentUrl('<?php echo $canvas_path; ?>' /* location of rpc_relay.html and canvas.html */);
google.friendconnect.container.renderMembersGadget(
 { id: 'gfci-member',
   site: '<?php echo gfci_sit(); ?>'},
  skin);
</script>
<?php
  echo $after_widget;
}

function widget_gfci_member_control() {
  $options = get_option(GFCI_MEMBER_WIDGET);
  if (!is_array($options)) {
    $options = array();
  }

  $widget_data = $_POST[GFCI_MEMBER_WIDGET];
  if ($widget_data['submit']) {
    $options['gadget_wid'] = $widget_data['gadget_wid'];
    $options['gadget_hei'] = $widget_data['gadget_hei'];
    $options['endcap_bkgd'] = $widget_data['endcap_bkgd'];
    $options['endcap_text'] = $widget_data['endcap_text'];
    $options['endcap_links'] = $widget_data['endcap_links'];
    $options['content_bkgd'] = $widget_data['content_bkgd'];
    $options['content_text'] = $widget_data['content_text'];
    $options['content_text2'] = $widget_data['content_text2'];
    $options['content_links'] = $widget_data['content_links'];
    $options['content_links2'] = $widget_data['content_links2'];
    $options['content_hlines'] = $widget_data['content_hlines'];
    $options['alt_bkgd'] = $widget_data['alt_bkgd'];
    $options['gfci_border'] = $widget_data['gfci_border'];
    $options['gfci_border2'] = $widget_data['gfci_border2'];

    update_option(GFCI_MEMBER_WIDGET, $options);
  }

  // Render form
  $gadget_wid = $options['gadget_wid'];
  $gadget_hei = $options['gadget_hei'];
  $endcap_bkgd = $options['endcap_bkgd'];
  $endcap_text = $options['endcap_text'];
  $endcap_links = $options['endcap_links'];
  $content_bkgd = $options['content_bkgd'];
  $content_text = $options['content_text'];
  $content_text2 = $options['content_text2'];
  $content_links = $options['content_links'];
  $content_links2 = $options['content_links2'];
  $content_hlines = $options['content_hlines'];
  $alt_bkgd = $options['alt_bkgd'];
  $gfci_border = $options['gfci_border'];
  $gfci_border2 = $options['gfci_border2'];
  
?>
<h3>Gadget Size (Min 200x200 pixels)</h3>
<table>
<tr>
<td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-gadget-wid">
  Width:
  </label></td>
<td><input class="widefat" 
    type="text"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[gadget_wid]" 
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-gadget-wid" 
    value="<?php echo $gadget_wid; ?>"/></td>
</tr>
<tr>
<td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-gadget-hei">
  Height:
  </label></td>
<td><input class="widefat" type="text" 
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[gadget_hei]" 
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-gadget-hei" 
    value="<?php echo $gadget_hei; ?>"/></td>
</tr>
</table>
<h3>Color Settings</h3>
<table>
<tr>
<td>
<table>
<tr><td>Format Example:</td><td><b>FFFFFF</b></td></tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-endcap-bkgd">
Endcap Bkgd:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[endcap_bkgd]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-endcap-bkgd"
    value="<?php echo $endcap_bkgd; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-endcap-text">
Endcap Text:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[endcap_text]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-endcap-text"
    value="<?php echo $endcap_text; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-endcap-links">
Endcap Links:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[endcap_links]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-endcap-links"
    value="<?php echo $endcap_links; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-content-bkgd">
Content Bkgd:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[content_bkgd]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-content-bkgd"
    value="<?php echo $content_bkgd; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-content-text">
Content Text:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[content_text]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-content-text"
    value="<?php echo $content_text; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-content-text2">
Sec. Content Text:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[content_text2]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-content-text2"
    value="<?php echo $content_text2; ?>"
    size="7"/></td>
</tr>
</table>
</td>
<td>
<table>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-content-links">
Content Links:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[content_links]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-content-links"
    value="<?php echo $content_links; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-content-links2">
Sec. Content Links:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[content_links2]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-content-links2"
    value="<?php echo $content_links2; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-content-hlines">
Content Headlines:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[content_hlines]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-content-hlines"
    value="<?php echo $content_hlines; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-alt-bkgd">
Alt. Background:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[alt_bkgd]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-alt-bkgd"
    value="<?php echo $alt_bkgd; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-gfci-border">
Inner Border:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[gfci_border]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-gfci-border"
    value="<?php echo $gfci_border; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo GFCI_MEMBER_WIDGET; ?>-gfci-border2">
Outer Border:</label></td>
<td><input class="widefat"
    name="<?php echo GFCI_MEMBER_WIDGET; ?>[gfci_border2]"
    type="text"
    id="<?php echo GFCI_MEMBER_WIDGET; ?>-gfci-border2"
    value="<?php echo $gfci_border2; ?>"
    size="7"/></td>
</tr>
</table></td></tr></table>
<input type="hidden" 
  name="<?php echo GFCI_MEMBER_WIDGET; ?>[submit]" 
  value="1"/>
<?php
}

?>
